<?php
// this is user callback object for processing Texy events (PHP5)
class myHandler {
  /**
   * User handler for code block
   *
   * @param TexyBlockParser
   * @param string  block type
   * @param string  text to highlight
   * @param string  language
   * @param TexyModifier modifier
   * @return TexyHtml
   */
  public function block($parser, $blocktype, $content, $lang, $modifier) {
    // handling only code blocks
    if ($blocktype !== 'block/code') {
      return version_compare(PHP_VERSION, '5.0.0', '>=') ? Texy::PROCEED : TEXY_PROCEED;
    }

    $texy = $parser->texy;

    $lang = strtoupper($lang);
    if ($lang == 'JAVASCRIPT') {
      $lang = 'JS';
    }
    // must be one of
    if (!in_array($lang, array('CPP', 'CSS', 'HTML', 'JAVA', 'PHP', 'JS', 'SQL'))) {
      return version_compare(PHP_VERSION, '5.0.0', '>=') ? Texy::PROCEED : TEXY_PROCEED;
    }

    // initialize syntax highlighter class
    $parser = new fshlParser('HTML_UTF8', P_TAB_INDENT);

    $content = $texy->blockModule->outdent($content);
    $content = $parser->highlightString($lang, $content);
    $content = $texy->protect($content);

    $elPre = TexyHtml::el('pre');
    if ($modifier) $modifier->decorate($texy, $elPre);
    $elPre->class = strtolower($lang);

    $elCode = $elPre->add('code', $content);

    return $elPre;
  }
}
